Bug 3416 - hardcoded jobtypes
: hardcoded jobtypes
Status: RESOLVED WONTFIX
: GRAM
wsrf managed job factory service
: 4.0.0
: PC Linux
: P3 normal
: ---
Assigned To:
:
:
:
:
  Show dependency treegraph
 
Reported: 2005-05-26 02:27 by
Modified: 2005-09-26 14:02 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2005-05-26 02:27:02
In this file:
gt4.0.0-all-source-installer/source-trees/ws-gram/common/schema/gram/job_description.xsd

the jobTypes are hardcoded.  This is bad, as it stops us from adding jobTypes,
which is very useful, and allows us to work around other problems with the way
gram works without disturbing the original behaviour.

Here's the change that makes all the difference:

383,392c383
<
<     <xsd:simpleType name="JobTypeEnumeration">
<         <xsd:restriction base="xsd:string">
<             <xsd:enumeration value="mpi"/>
<             <xsd:enumeration value="single"/>
<             <xsd:enumeration value="multiple"/>
<             <xsd:enumeration value="condor"/>
<         </xsd:restriction>
<     </xsd:simpleType>
<     <xsd:element name="jobType" type="tns:JobTypeEnumeration">
---
>     <xsd:element name="jobType" type="xsd:string">
------- Comment #1 From 2005-07-18 13:04:36 -------
I'm nervous about making this a general string since this is designed to select
specific modes of operation.  What limitations are you encountering that require
unrestricted jobType values?
------- Comment #2 From 2005-07-18 19:25:02 -------
Subject: Re:  hardcoded jobtypes

I'm working on making gt4 work on a gateway machine that doesn't have
access to our cluster shared filesystems.

Here's my reasoning:

- I want to retain the existing pbs adapter behaviour
- I want to add a new jobType that doesn't do checking for existence of
executables, files or directories that definitely wont exist on the
gateway, but will exist on the cluster
- Each adapter already checks for it's own valid jobTypes, so it's
unnecessarily limiting to add arbitrary values to the xsd
- as a general point, what if some new whizzbang cycle scavenging system
comes along that you want to support?  With the current method, you will
need to change your xsd and regenerate all the gram code, whereas if you
just get an "invalid jobType" error from the adapter and pass it along,
you can add new adapters and jobTypes easily.

Currently I've got a dirty hack that uses jobType=condor in the pbs
adapter, as it is unused.  I would rather it was done properly though.

cheers,

Damon

On Mon, 2005-07-18 at 13:04 -0500, bugzilla-daemon@mcs.anl.gov wrote:
> http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=3416
> 
> 
> 
> 
> 
> ------- Additional Comments From lane@mcs.anl.gov  2005-07-18 13:04 -------
> I'm nervous about making this a general string since this is designed to select
> specific modes of operation.  What limitations are you encountering that require
> unrestricted jobType values?
> 
> 
> 
> ------- You are receiving this mail because: -------
> You reported the bug, or are watching the reporter.

------- Comment #3 From 2005-09-26 14:02:24 -------
We've just added support for handling extension elements in the job
description.
 I'm going to ask that you use that instead of us changing the jobType element
definition in the schema.  Here is the documentation:

http://www-unix.globus.org/toolkit/docs/4.0/execution/wsgram/admin-index.html#s-wsgram-admin-extensions

This will allow you to modify and select the behavior of the PBS adapter
without
using the jobType=condor hack.  Feel free to ask questions about this on the
discuss list if you run into problems.

Also, if you make it generally applicable, send us a patch and we'll be happy
to
add the functionality to the official adapter code.
------- Comment #4 From 2005-09-27 16:05:03 -------
Subject: Re:  hardcoded jobtypes

Ok, but I still think those hardcoded jobTypes are a bad idea in general, and
that you're just putting off the inevitable when some other completely valid
job type comes along.

Quoting bugzilla-daemon@mcs.anl.gov:

> http://bugzilla.globus.org/bugzilla/show_bug.cgi?id=3416
>
> lane@mcs.anl.gov changed:
>
>           What    |Removed                     |Added
> ----------------------------------------------------------------------------
>             Status|ASSIGNED                    |RESOLVED
>         Resolution|                            |WONTFIX
>
>
>
> ------- Additional Comments From lane@mcs.anl.gov  2005-09-26 14:02 -------
> We've just added support for handling extension elements in the job 
> description.
> I'm going to ask that you use that instead of us changing the jobType element
> definition in the schema.  Here is the documentation:
>
> http://www-unix.globus.org/toolkit/docs/4.0/execution/wsgram/admin-index.html#s-wsgram-admin-extensions
>
> This will allow you to modify and select the behavior of the PBS 
> adapter without
> using the jobType=condor hack.  Feel free to ask questions about this on the
> discuss list if you run into problems.
>
> Also, if you make it generally applicable, send us a patch and we'll 
> be happy to
> add the functionality to the official adapter code.
>
>
>
> ------- You are receiving this mail because: -------
> You reported the bug, or are watching the reporter.
>